diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index 7c9cca677..128369d58 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -225,7 +225,7 @@ public abstract class EntityLiving extends Entity
                     double motionX = random.nextGaussian() * 0.02D;
                     double motionY = random.nextGaussian() * 0.02D;
                     double motionZ = random.nextGaussian() * 0.02D;
-                    world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, y + (double)(random.nextFloat() * bbHeight), (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, motionX, motionY, motionZ);
+                    world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, y + (double)(random.nextFloat() * bbHeight), (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, motionX, motionY, motionZ, 0);
                 }
 
             }
@@ -257,7 +257,7 @@ public abstract class EntityLiving extends Entity
                     double offX = random.nextFloat() - random.nextFloat();
                     double offY = random.nextFloat() - random.nextFloat();
                     double offZ = random.nextFloat() - random.nextFloat();
-                    world.spawnParticle("bubble", x + offX, y + offY, z + offZ, xd, yd, zd);
+                    world.spawnParticle("bubble", x + offX, y + offY, z + offZ, xd, yd, zd, 0);
                 }
 
                 hurt(null, 2, DamageType.DROWN);
@@ -277,7 +277,7 @@ public abstract class EntityLiving extends Entity
             double d1 = random.nextGaussian() * 0.02D;
             double d2 = random.nextGaussian() * 0.02D;
             double d3 = 10D;
-            world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d * d3, (y + (double)(random.nextFloat() * bbHeight)) - d1 * d3, (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d2 * d3, d, d1, d2);
+            world.spawnParticle("explode", (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d * d3, (y + (double)(random.nextFloat() * bbHeight)) - d1 * d3, (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth - d2 * d3, d, d1, d2, 0);
         }
 
     }
diff --git a/src/main/java/net/minecraft/core/entity/EntityTNT.java b/src/main/java/net/minecraft/core/entity/EntityTNT.java
index 6df79289e..0e64d0771 100644
--- a/src/main/java/net/minecraft/core/entity/EntityTNT.java
+++ b/src/main/java/net/minecraft/core/entity/EntityTNT.java
@@ -82,7 +82,7 @@ public class EntityTNT extends Entity
             }
         } else
         {
-            world.spawnParticle("smoke", x, y + 0.5D, z, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("smoke", x, y + 0.5D, z, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java b/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
index 3ed05374d..ccd871241 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
@@ -1,12 +1,6 @@
 package net.minecraft.core.entity.animal;
 
-import java.util.Collection;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-
 import com.mojang.nbt.CompoundTag;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
@@ -18,6 +12,11 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
 public class EntityFireflyCluster extends EntityFlying
         implements IAnimal
 {
@@ -300,7 +299,7 @@ public class EntityFireflyCluster extends EntityFlying
 		double dz = (random.nextFloat() * 2F - 1F) * (bbWidth);
 		
 		if (random.nextInt(Math.max(1, 10 - getFireflyCount())) == 0) {
-			world.spawnParticle(getColor().getParticleName(), x + dx, y + dy, z + dz, xd, yd, zd, 256D);
+			world.spawnParticle(getColor().getParticleName(), x + dx, y + dy, z + dz, xd, yd, zd, 0, 256D);
 		}
 		
 		if(world.isClientSide) {
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index f46ed46a3..2792ac683 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -441,7 +441,7 @@ public class EntityWolf extends EntityAnimal
                 {
                     double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth * 0.5F;
                     double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth * 0.5F;
-                    world.spawnParticle("splash", x + offX, f + 0.8F, z + offZ, xd, yd, zd);
+                    world.spawnParticle("splash", x + offX, f + 0.8F, z + offZ, xd, yd, zd, 0);
                 }
 
             }
@@ -749,7 +749,7 @@ public class EntityWolf extends EntityAnimal
             double motionX = random.nextGaussian() * 0.02D;
             double motionY = random.nextGaussian() * 0.02D;
             double motionZ = random.nextGaussian() * 0.02D;
-            world.spawnParticle(s, (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, y + 0.5D + (double)(random.nextFloat() * bbHeight), (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, motionX, motionY, motionZ);
+            world.spawnParticle(s, (x + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, y + 0.5D + (double)(random.nextFloat() * bbHeight), (z + (double)(random.nextFloat() * bbWidth * 2.0F)) - (double) bbWidth, motionX, motionY, motionZ, 0);
         }
 
     }
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
index c3bc0d14c..e1b74219a 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySlime.java
@@ -113,7 +113,7 @@ public class EntitySlime extends EntityLiving
                 double f1 = random.nextFloat() * 0.5D + 0.5D;
                 double f2 = MathHelper.sin(f) * (float)i * 0.5D * f1;
                 double f3 = MathHelper.cos(f) * (float)i * 0.5D * f1;
-                world.spawnParticle("item", x + f2, bb.minY, z + f3, Item.slimeball.id, 0.0D, 0.0D);
+                world.spawnParticle("item", x + f2, bb.minY, z + f3, 0.0, 0.0D, 0.0D, Item.slimeball.id);
             }
 
             if(i > 2)
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java b/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java
index 3d5b39cef..f9bccaf6e 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityArrow.java
@@ -158,8 +158,8 @@ public class EntityArrow extends EntityProjectile
         }
         else if(this instanceof EntityArrowGolden)
         {
-            world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D);
-            world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D);
+            world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
+            world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
         }
         super.tick();
     }
@@ -217,7 +217,7 @@ public class EntityArrow extends EntityProjectile
             }
             for(int j = 0; j < 4; j++)
             {
-                world.spawnParticle("item", x, y, z, Item.ammoArrow.id, 0.0D, 0.0D);
+                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Item.ammoArrow.id);
             }
             remove();
             return;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java b/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java
index efa22d751..c11334787 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityArrowPurple.java
@@ -42,7 +42,7 @@ public class EntityArrowPurple extends EntityArrow
         world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
         for(int j = 0; j < 4; j++)
         {
-            world.spawnParticle("item", x, y, z, Item.ammoArrowPurple.id, 0.0D, 0.0D);
+            world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Item.ammoArrowPurple.id);
         }
         remove();
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
index c82131758..de6591856 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
@@ -38,6 +38,6 @@ public class EntityCannonball extends EntityProjectile
     @Override
     public void afterTick(){
         super.afterTick();
-        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D);
+        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
     }
 }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
index 9a899120d..0a6caff95 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
@@ -1,7 +1,5 @@
 package net.minecraft.core.entity.projectile;
 
-import java.util.List;
-
 import net.minecraft.core.HitResult;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLiving;
@@ -11,6 +9,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 
+import java.util.List;
+
 public class EntityCannonballBouncy extends EntityCannonball
 {
     private int fuse = 50;
@@ -120,12 +120,12 @@ public class EntityCannonballBouncy extends EntityCannonball
             for(int i = 0; i < 4; i++)
             {
                 double particleDistance = 0.25D;
-                world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd);
+                world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
             }
 
             deceleration = 0.8F;
         }
-        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D);
+        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
         xd *= deceleration;
         yd *= deceleration;
         zd *= deceleration;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
index 1a24bf808..251f33b33 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
@@ -6,13 +6,9 @@ import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.util.helper.MathHelper;
-import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 
-import java.util.List;
-
 // Referenced classes of package net.minecraft.src:
 //            Entity, AxisAlignedBB, MathHelper, EntityLiving, 
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound
@@ -73,8 +69,8 @@ public class EntityFireball extends EntityProjectile
 	public void tick()
     {
         remainingFireTicks = 10;
-        world.spawnParticle("flame", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D);
-        world.spawnParticle("flame", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D);
+        world.spawnParticle("flame", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
+        world.spawnParticle("flame", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
         super.tick();
     }
     public void onHit(HitResult result){
@@ -99,7 +95,7 @@ public class EntityFireball extends EntityProjectile
         xd += accelX;
         yd += accelY;
         zd += accelZ;
-        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D);
+        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
     }
     @Override
 	public boolean isPickable()
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java
index 07bc09a96..be5cb3aee 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityProjectile.java
@@ -199,7 +199,7 @@ public class EntityProjectile extends Entity {
         if (modelItem != null){
             for(int j = 0; j < 8; j++)
             {
-                world.spawnParticle("item", x, y, z, modelItem.id, 0.0D, 0.0D);
+                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, modelItem.id);
             }
         }
         remove();
@@ -239,7 +239,7 @@ public class EntityProjectile extends Entity {
         for(int k = 0; k < 4; k++)
         {
             double particleDistance = 0.25F;
-            world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd);
+            world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
         }
 
         projectileSpeed = 0.8F;
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 6c59604f7..2534592c4 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -1,22 +1,24 @@
 package net.minecraft.core.entity.vehicle;
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.client.entity.player.EntityClientPlayerMP;
 import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet26BoatControl;
-import net.minecraft.core.util.helper.MathHelper;
-import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.world.World;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
 import net.minecraft.server.entity.player.EntityPlayerMP;
 
 import java.util.List;
@@ -99,7 +101,7 @@ public class EntityBoat extends Entity
         int numParticles = random.nextInt(8) + 1;
         for (int q = 0; q < numParticles; q++)
         {
-            world.spawnParticle("boatbreak", x, y, z, xd, yd, zd);
+            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Block.planksOak.id, 0, Side.BOTTOM));
         }
         if(world.isClientSide || removed)
         {
@@ -281,12 +283,12 @@ public class EntityBoat extends Entity
                 {
                     double posX = (x - d12 * d18 * 0.8D) + d15 * d20;
                     double posZ = z - d15 * d18 * 0.8D - d12 * d20;
-                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd);
+                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd, 0);
                 } else
                 {
                     double posX = x + d12 + d15 * d18 * 0.7D;
                     double posZ = (z + d15) - d12 * d18 * 0.7D;
-                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd);
+                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd, 0);
                 }
             }
 
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index cba03dafb..867ed29f3 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -17,7 +17,6 @@ import net.minecraft.core.player.inventory.IInventory;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRail;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 
 import java.util.List;
@@ -589,7 +588,7 @@ label0:
             {
                 pushX = pushZ = 0.0D;
             }
-            world.spawnParticle("largesmoke", x, y + 0.8D, z, 0.0D, 0.0D, 0.0D);
+            world.spawnParticle("largesmoke", x, y + 0.8D, z, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/item/ItemBucket.java b/src/main/java/net/minecraft/core/item/ItemBucket.java
index 1a3f5603b..7786f940b 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -89,7 +89,7 @@ public class ItemBucket extends Item
 			if(world.dimension == Dimension.nether && idToPlace == Block.fluidWaterFlowing.id) {
 				world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
 				for (int l = 0; l < 8; l++) {
-					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D);
+					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
 				}
 			} else {
 				if(idToPlace == Block.fluidWaterFlowing.id) {
diff --git a/src/main/java/net/minecraft/core/item/ItemDye.java b/src/main/java/net/minecraft/core/item/ItemDye.java
index 128d44818..ef766900a 100644
--- a/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -130,7 +130,7 @@ label0:
                                 world.setBlockWithNotify(k1, l1, i2, Block.tallgrass.id);
                             continue;
                         }
-                        int r = itemRand.nextInt(10);
+                        int r = itemRand.nextInt(12);
                         Biome biome = world.getBlockBiome(k1, l1, i2);
                         if (r < 1){
                             world.setBlockWithNotify(k1, l1, i2, Block.flowerYellow.id);
@@ -142,6 +142,8 @@ label0:
                             world.setBlockWithNotify(k1, l1, i2, Block.flowerPurple.id);
                         } else if (r < 8 && (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA)) {
                             world.setBlockWithNotify(k1, l1, i2, Block.flowerLightBlue.id);
+                        } else if (r < 10 && (biome == Biomes.OVERWORLD_PLAINS || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_OUTBACK || biome == Biomes.OVERWORLD_OUTBACK_GRASSY)) {
+                            world.setBlockWithNotify(k1, l1, i2, Block.flowerOrange.id);
                         }
                     }
                 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
index a66e60b15..aeffaf830 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
@@ -29,6 +29,7 @@ public class SpawnParticleCommand extends Command {
         double motionX = 0;
         double motionY = 0;
         double motionZ = 0;
+        int data = 0;
         Double maxDistance = null;
         if (args.length >= 1){
             particleKey = args[0];
@@ -50,20 +51,23 @@ public class SpawnParticleCommand extends Command {
                     motionX = Double.parseDouble(args[4]);
                     motionY = Double.parseDouble(args[5]);
                     motionZ = Double.parseDouble(args[6]);
-                    if (args.length == 8){
-                        maxDistance = Double.parseDouble(args[7]);
+                    if (args.length >= 8){
+                        data = Integer.parseInt(args[7]);
+                        if (args.length == 9){
+                            maxDistance = Double.parseDouble(args[8]);
+                        }
                     }
                 }
             }
         }
         if (particleKey != null && x != null){
             if (handler instanceof ServerCommandHandler){
-                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, maxDistance == null ? 16 : maxDistance, dimension, new Packet63SpawnParticleEffect(particleKey, x, y, z, motionX, motionY, motionZ));
+                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, maxDistance == null ? 16 : maxDistance, dimension, new Packet63SpawnParticleEffect(particleKey, x, y, z, motionX, motionY, motionZ, data));
             } else if (handler instanceof ClientCommandHandler){
                 if (maxDistance == null){
-                    ((ClientCommandHandler) handler).minecraft.renderGlobal.addParticle(particleKey, x, y, z, motionX, motionY, motionZ);
+                    ((ClientCommandHandler) handler).minecraft.renderGlobal.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data);
                 } else {
-                    ((ClientCommandHandler) handler).minecraft.renderGlobal.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, maxDistance);
+                    ((ClientCommandHandler) handler).minecraft.renderGlobal.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, maxDistance);
                 }
             }
             return true;
@@ -84,6 +88,7 @@ public class SpawnParticleCommand extends Command {
         }
         sender.sendMessage("/spawnparticle <ParticleKey> <x> <y> <z>");
         sender.sendMessage("/spawnparticle <ParticleKey> <x> <y> <z> <MotionX> <MotionY> <MotionZ>");
-        sender.sendMessage("/spawnparticle <ParticleKey> <x> <y> <z> <MotionX> <MotionY> <MotionZ> <MaxDistance>");
+        sender.sendMessage("/spawnparticle <ParticleKey> <x> <y> <z> <MotionX> <MotionY> <MotionZ> <data>");
+        sender.sendMessage("/spawnparticle <ParticleKey> <x> <y> <z> <MotionX> <MotionY> <MotionZ> <data> <MaxDistance>");
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java b/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java
index 178243b0a..a239b82b5 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java
@@ -14,6 +14,7 @@ public class Packet63SpawnParticleEffect extends Packet{
     public double motionX;
     public double motionY;
     public double motionZ;
+    public int data;
     public double maxDistance;
     public boolean isGroup = false;
     public byte amount;
@@ -28,18 +29,18 @@ public class Packet63SpawnParticleEffect extends Packet{
 
     }
     public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
-                                       double motionX, double motionY, double motionZ){
-        this(particleKey, x, y, z, motionX, motionY, motionZ, 16D);
+                                       double motionX, double motionY, double motionZ, int data){
+        this(particleKey, x, y, z, motionX, motionY, motionZ, data, 16D);
     }
     public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
-                                       double motionX, double motionY, double motionZ, double maxDistance){
-        this(particleKey, x, y, z, motionX, motionY, motionZ, maxDistance,
-                (byte) -1, 0, 0, 0, 0, 0, 0);
+                                       double motionX, double motionY, double motionZ, int data, double maxDistance){
+        this(particleKey, x, y, z, motionX, motionY, motionZ, data,
+                maxDistance, (byte) -1, 0, 0, 0, 0, 0, 0);
 
     }
     public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
                                        double motionX, double motionY, double motionZ,
-                                       double maxDistance, byte amount, float randOffX,
+                                       int data, double maxDistance, byte amount, float randOffX,
                                        float randOffY, float randOffZ, float randMotionX,
                                        float randMotionY, float randMotionZ){
         this.particleKey = particleKey;
@@ -49,6 +50,7 @@ public class Packet63SpawnParticleEffect extends Packet{
         this.motionX = motionX;
         this.motionY = motionY;
         this.motionZ = motionZ;
+        this.data = data;
         this.maxDistance = maxDistance;
         if (amount > 0){
             this.isGroup = true;
diff --git a/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java b/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
new file mode 100644
index 000000000..c6e247265
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
@@ -0,0 +1,16 @@
+package net.minecraft.core.util.helper;
+
+public class BlockParticleHelper {
+    public static int encodeBlockData(int blockId, int meta, Side side){
+        return blockId & 0x3FFF | (meta & 0xFF) << 14 | (side.getId() << 22);
+    }
+    public static int decodeBlockID(int data){
+        return data & 0x3FFF;
+    }
+    public static int decodeBlockMeta(int data){
+        return data >> 14 & 0xFF;
+    }
+    public static int decodeBlockSide(int data){
+        return data >> 22 & 0xF;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index 07416fc62..8efb8d859 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -83,8 +83,8 @@ public class Explosion {
                 d3 *= d7;
                 d4 *= d7;
                 d5 *= d7;
-                worldObj.spawnParticle("explode", (xPos + explosionX) / 2D, (yPos + explosionY) / 2D, (zPos + explosionZ) / 2D, d3, d4, d5);
-                worldObj.spawnParticle("smoke", xPos, yPos, zPos, d3, d4, d5);
+                worldObj.spawnParticle("explode", (xPos + explosionX) / 2D, (yPos + explosionY) / 2D, (zPos + explosionZ) / 2D, d3, d4, d5, 0);
+                worldObj.spawnParticle("smoke", xPos, yPos, zPos, d3, d4, d5, 0);
             }
             if(id > 0)
             {
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 09bfbbcac..02bff9f40 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -160,8 +160,8 @@ public class ExplosionCannonball extends Explosion{
                 d3 *= d7;
                 d4 *= d7;
                 d5 *= d7;
-                worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5);
-                worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5);
+                worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5, 0 );
+                worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
             }
             if(i1 > 0 && (Block.blocksList[i1].id == Block.glass.id
                     ||  Block.blocksList[i1].blockMaterial == Material.topSnow
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 0787f49d3..6bb967ef3 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -27,10 +27,10 @@ public interface LevelListener
                    float volume, float pitch);
 
     void addParticle(String particleKey, double x, double y, double z,
-                     double motionX, double motionY, double motionZ, double maxDistance);
+                     double motionX, double motionY, double motionZ, int data, double maxDistance);
 
     void addParticle(String particleKey, double x, double y, double z,
-                     double motionX, double motionY, double motionZ);
+                     double motionX, double motionY, double motionZ, int data);
 
     void entityAdded(Entity entity);
 
